package com.wms.utils;

import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Base64;
import java.util.Map;

import jakarta.servlet.http.HttpServletRequest;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.HttpEntity;
import org.apache.http.ParseException;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;

/**
 * Http工具类
 */
public class HttpUtils {

    /**
     * 获取请求的ip地址
     * @param request 请求
     * @return ip地址
     */
    public static String getIpAddr(HttpServletRequest request) {
        String ip = request.getHeader("x-forwarded-for");
        if (ip == null || ip.isEmpty() || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getHeader("Proxy-Client-IP");
        }
        if (ip == null || ip.isEmpty() || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getHeader("WL-Proxy-Client-IP");
        }
        if (ip == null || ip.isEmpty() || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getRemoteAddr();
        }
        if (ip != null && ip.indexOf(",") > 0) {
            String[] parts = ip.split(",");
            for (String part : parts) {
                if (!part.isEmpty() && !"unknown".equalsIgnoreCase(part)) {
                    ip = part.trim();
                    break;
                }
            }
        }
        if ("0:0:0:0:0:0:0:1".equals(ip)) {
            ip = "127.0.0.1";
        }
        return ip;
    }

    /**
     * 发送HttpGet请求(无参数)
     * @param url 地址
     * @return 响应结果
     */
    public static String sendHttpGet(String url) {
        String result = "";
        CloseableHttpClient httpClient = null;
        CloseableHttpResponse response = null;
        try {
            httpClient = HttpClients.createDefault();
            HttpGet httpget = new HttpGet(url);
            response = httpClient.execute(httpget);
            HttpEntity entity = null;
            if (response != null) {
                entity = response.getEntity();
            }
            if (entity != null) {
                result = EntityUtils.toString(entity);
            }
        } catch (ParseException | IOException e) {
            e.printStackTrace();
        } finally {
            if(response!=null){ try{response.close();}catch (IOException e){ e.printStackTrace();} }
            if(httpClient!=null){ try{httpClient.close();}catch(IOException e){ e.printStackTrace();} }
        }
        return result;
    }

    /**
     * 发送HttpGet请求(带参数)
     * @param url 地址
     * @param header 参数放在请求头里面
     * @return 响应结果
     */
    public static String sendHttpGet(String url, Map<String, String> header) {
        if (header == null) {// 没有参数
            return sendHttpGet(url);
        }
        String result = "";
        CloseableHttpClient httpClient = null;
        CloseableHttpResponse response = null;
        try {
            httpClient = HttpClients.createDefault();
            HttpGet httpGet = new HttpGet(url);
            // 设置超时时间
            RequestConfig requestConfig = RequestConfig.custom()
                    .setConnectTimeout(5000)
                    .setConnectionRequestTimeout(1000)
                    .setSocketTimeout(5000).build();
            httpGet.setConfig(requestConfig);
            for(Map.Entry<String, String> entry : header.entrySet()){

                httpGet.setHeader(entry.getKey(), entry.getValue());
            }
            response = httpClient.execute(httpGet);
            HttpEntity entity = null;
            if (response != null) {
                entity = response.getEntity();
            }
            if (entity != null) {
                result = EntityUtils.toString(entity);
            }
        } catch (ParseException | IOException e) {
            e.printStackTrace();
        } finally {
            if(response!=null){ try{response.close();}catch (IOException e){ e.printStackTrace();} }
            if(httpClient!=null){ try{httpClient.close();}catch(IOException e){ e.printStackTrace();} }
        }
        return result;
    }

    /**
     * 发送httpPost请求（不需要认证信息）
     * @param url 目的地址
     * @param param 参数
     * @return 请求结果
     */
    public static String sendHttpPostWithoutToken(String url,String param) {
        return sendHttpPost(url, param, null, null, null);
    }

    /**
     * 发送httpPost请求
     * @param url 目的地址
     * @param param 参数
     * @param token 认证信息
     * @param userName 登录账户
     * @param password 登录密码
     * @return 请求结果
     */
    public static String sendHttpPost(String url, String param, String token, String userName, String password) {
        String data="";
        CloseableHttpClient httpClient = null;
        CloseableHttpResponse response = null;
        try {
            httpClient = HttpClients.createDefault();
            HttpPost httppost = new HttpPost(url);
            RequestConfig requestConfig = RequestConfig.custom()
                    .setConnectTimeout(5000)
                    .setConnectionRequestTimeout(5000)
                    .setSocketTimeout(5000).build();
            httppost.setConfig(requestConfig);
            httppost.setHeader("Content-Type", "application/json;charset=UTF-8");
            if (StringUtils.isEmpty(token) && StringUtils.isNotEmpty(userName) && StringUtils.isNotEmpty(password)) {
                httppost.setHeader("Authorization", "Basic " + Base64.getUrlEncoder().encodeToString((userName + ":" + password).getBytes()));
            } else {
                httppost.setHeader("Authorization", "Bearer " + token);
            }
            StringEntity se = new StringEntity(param, Charset.forName("UTF-8"));
            se.setContentType("text/json");
            se.setContentEncoding("UTF-8");
            httppost.setEntity(se);
            response = httpClient.execute(httppost);
            data = EntityUtils.toString(response.getEntity(), "utf-8");
            EntityUtils.consume(response.getEntity());
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if(response!=null){ try{response.close();}catch (IOException e){ e.printStackTrace();} }
            if(httpClient!=null){ try{httpClient.close();}catch(IOException e){ e.printStackTrace();} }
        }
        return data;
    }

    /**
     * 发送httpPost请求
     * @param url 目的地址
     * @param param 参数
     * @param token 认证信息
     * @param userName 登录账户
     * @param password 登录密码
     * @return 请求结果
     */
    public static String sendHttpPostForm(String url, String param, String token, String userName, String password) {

        String data="";
        CloseableHttpClient httpClient = null;
        CloseableHttpResponse response = null;
        try {
            httpClient = HttpClients.createDefault();
            HttpPost httppost = new HttpPost(url);
            RequestConfig requestConfig = RequestConfig.custom()
                    .setConnectTimeout(5000)
                    .setConnectionRequestTimeout(1000)
                    .setSocketTimeout(5000).build();
            httppost.setConfig(requestConfig);
            httppost.setHeader("Content-Type", "application/x-www-form-urlencoded;charset=UTF-8");
            if (StringUtils.isEmpty(token) && StringUtils.isNotEmpty(userName) && StringUtils.isNotEmpty(password)) {
                httppost.setHeader("Authorization", "Basic " + Base64.getUrlEncoder().encodeToString((userName + ":" + password).getBytes()));
            } else {
                httppost.setHeader("Authorization", "Bearer " + token);
            }
            StringEntity se = new StringEntity(param, Charset.forName("UTF-8"));
            se.setContentType("application/x-www-form-urlencoded");
            se.setContentEncoding("UTF-8");
            httppost.setEntity(se);
            response = httpClient.execute(httppost);
            data = EntityUtils.toString(response.getEntity(), "utf-8");
            EntityUtils.consume(response.getEntity());
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if(response!=null){ try{response.close();}catch (IOException e){ e.printStackTrace();} }
            if(httpClient!=null){ try{httpClient.close();}catch(IOException e){ e.printStackTrace();} }
        }
        return data;
    }
}
